#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"

#define LOADR 5.0
#define UMIN 0.9

int main(void) {
	ADCSRA |= _BV(ADEN); //wcz ADC
	ADMUX |= _BV(REFS0); //AVCC
	//preskaler 128
	ADCSRA |= _BV(ADPS0)|_BV(ADPS1)|_BV(ADPS2);
	//wcz MOSFET
	DDRB = _BV(DDD0);
	PORTB |= _BV(PB0);
	lcdInit();
	lcdInitPrintf();
	float capacity = 0.0;
	while (1) {
		//zmierz napicie
		ADCSRA |= _BV(ADSC);
		while(ADCSRA & _BV(ADSC));
		float u = ADCW * 5.0 / 1024;
		lcdGotoXY(0, 0);
		printf("U=%.2fV", u);
		//zaktualizuj pojemno
		float i = u / LOADR;
		capacity += i;
		printf(" I=%.3fA", i);
		lcdGotoXY(0, 1);
		printf("C=%.1f mAh", capacity);
		//jeli napicie jest za niskie,
		//odcz obcienie i zakocz
		if (u < UMIN) {
			lcdGotoXY(13, 1);
			printf("end");
			PORTB &= ~_BV(PB0);
			while (1);
		}
		_delay_ms(3600);
	}
}
